IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SPUSS_236_KUDUZ_IZLEM]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE SPUSS_236_KUDUZ_IZLEM
GO

CREATE PROCEDURE [dbo].[SPUSS_236_KUDUZ_IZLEM] 
	@HDOSYAID INT=0,
	@HKUDUZIZLEMID INT=0,
	@TUMUNUTEKRAR BIT = 0	 
AS
BEGIN
	--SPUSS_236_KUDUZ_IZLEM 3439329,54659290,1
	DECLARE @HATA NVARCHAR(2000) = ''
	DECLARE @MESAJ NVARCHAR(2000) = ''
	DECLARE @SAYIHATA BIT = 0
	DECLARE @XMLBASLIK NVARCHAR(2000) = ''
	DECLARE @SUBEID INT = 1
	DECLARE @GONDERIMTABLOSU TABLE 
		(
			GONDERILECEKXML XML,
			HATA NVARCHAR(2000),
			MESAJ NVARCHAR(2000),	
			XMLBASLIK NVARCHAR(3500),
			TABLOID INT,
			MINID INT,
			MAXID INT
		)


	IF OBJECT_ID('tempdb..#TMPDOSYA') IS NOT NULL 
		DROP TABLE #TMPDOSYA
	IF OBJECT_ID('tempdb..#TMPKUDUZIZLEM') IS NOT NULL 
		DROP TABLE #TMPKUDUZIZLEM



	SELECT 
		HDOSYA.SUBEID AS HDOSYA_SUBEID,
		SUBELER.SUBEADI AS SUBELER_SUBEADI,
		HDOSYA.SNOTAKIPNO AS HDOSYA_SNOTAKIPNO,		
		ISNULL((SELECT TOP 1 VALUESTR FROM CONFIG WITH(NOLOCK) WHERE SECTIONSTR='Saglik-Net' AND PROGNAME='MEDISOFT' AND KEYNAME= CONVERT(VARCHAR,HDOSYA.SUBEID)+' numaralı şubenin kurum numarası'),'') AS SAGLIKNETKURUMKODU				
	INTO #TMPDOSYA
	FROM
		HDOSYA WITH(NOLOCK)
		LEFT JOIN SUBELER WITH(NOLOCK) ON SUBELER.SUBEID = HDOSYA.SUBEID
	WHERE
		HDOSYA.HDOSYAID = @HDOSYAID		
		

    SELECT HKUDUZPROFILAKSIIZLEM.UYGULANANPROFLAKSIID AS UYGULANANPROFLAKSIID ,		
			HKUDUZPROFILAKSIIZLEM.PROFILAKSISISONLANDIRMADURUMUID AS PROFLAKSISONLANDIRMAID,
			HKUDUZPROFILAKSIIZLEM.IMMUNOGLOBULINTURUID AS IMMUNOGLOBULINTURUID,
			HKUDUZPROFILAKSIIZLEM.IMMUNOGLOBULINMIKTARI AS IMMUNOGLOBULINMIKTARI ,
			HKUDUZPROFILAKSIIZLEM.KILO AS KILO,
			HKPROFLAKSISON.KUDUZPROFLAKSISONLANDIRMADURUMUADI AS PROFLAKSISONLANDIRMAADI,
			UYGPROFLAKSI.UYGULANANKUDUZPROFLAKSISIADI AS UYGKPROFLAKSISIADI 
 	INTO #TMPKUDUZIZLEM
	FROM HDOSYA WITH(NOLOCK)
	 INNER JOIN HMUAYENE WITH(NOLOCK) ON HMUAYENE.HDOSYAID = HDOSYA.HDOSYAID
	 LEFT JOIN HKUDUZPROFILAKSIIZLEM  WITH(NOLOCK) ON HKUDUZPROFILAKSIIZLEM.HMUAYENEID = HMUAYENE.HMUAYENEID
	 LEFT JOIN TSKRSKUDUZPROFLAKSISONLANDIRMADURUMU HKPROFLAKSISON WITH(NOLOCK) ON HKUDUZPROFILAKSIIZLEM.PROFILAKSISISONLANDIRMADURUMUID = HKPROFLAKSISON.KUDUZPROFLAKSISONLANDIRMADURUMUKODU
	 LEFT JOIN TSKRSUYGULANANKUDUZPROFLAKSISI UYGPROFLAKSI WITH(NOLOCK) ON HKUDUZPROFILAKSIIZLEM.UYGULANANPROFLAKSIID = UYGPROFLAKSI.UYGULANANKUDUZPROFLAKSISIKODU
	 LEFT JOIN TSKRSIMMUNOGLUBINTURU IMMUNOGLUBINTURU WITH(NOLOCK) ON HKUDUZPROFILAKSIIZLEM.IMMUNOGLOBULINTURUID = IMMUNOGLUBINTURU.IMMUNOGLUBINTURUKODU
	WHERE HDOSYA.HDOSYAID = @HDOSYAID
		AND (@HKUDUZIZLEMID=0 OR HKUDUZPROFILAKSIIZLEM.HKUDUZPROFILAKSIIZLEMID = @HKUDUZIZLEMID)
	--	AND (@TUMUNUTEKRAR=1 OR (@TUMUNUTEKRAR=0 AND ISNULL(HYIZLEM.OZELLIKLIIZLEMGONDERILDI,0)=1))
 
	
	

			      
	IF (SELECT COUNT(*) FROM #TMPKUDUZIZLEM) = 0
	BEGIN
		SET @SAYIHATA = 1 
		SET @MESAJ = @MESAJ + 'Silinecek kuduz izlem bulunmadı'
	END

	IF (SELECT COUNT(*) FROM #TMPDOSYA WHERE HDOSYA_SUBEID IS NULL) > 0 
		SET @HATA = @HATA + 'İşlemin şube kaydı bulunamadı! '

	--IF (SELECT HDOSYA_SUBEID FROM #TMPDOSYA WHERE ISNULL(HDOSYA_SNOTAKIPNO,'')='') > 0 
	--	SET @HATA = @HATA + 'Sağlık Net hasta takip numarası alınmadan USS sistemine Kuduz izlem kaydı yapılamaz. '

	IF @HATA='' AND @SAYIHATA=0
	BEGIN		
		SELECT @SUBEID = HDOSYA_SUBEID FROM #TMPDOSYA
		DECLARE @TBLXMLBASLIK TABLE (XMLBASLIK NVARCHAR(2000), HATA NVARCHAR(2000),MESAJ NVARCHAR(2000))
		INSERT INTO @TBLXMLBASLIK (XMLBASLIK, HATA, MESAJ) EXEC SPUSS_000_XML_BASLIK @SUBEID		
		SELECT @HATA=@HATA+HATA, @MESAJ=@MESAJ+MESAJ, @XMLBASLIK=XMLBASLIK FROM @TBLXMLBASLIK		
	END

	IF @HATA = '' AND @SAYIHATA = 0
	BEGIN
	

					
							BEGIN TRY

								INSERT INTO @GONDERIMTABLOSU (GONDERILECEKXML,HATA,MESAJ,XMLBASLIK,TABLOID,MINID,MAXID)
								SELECT							 
									(

											SELECT 
												NEWID() AS 'messageGuid/@value',
												'1' AS 'messageType/@version',
												'0a9ba485-e7e0-4abb-9c86-0a14fd364bb8' AS 'messageType/@codeSystemGuid' ,
												'236' AS 'messageType/@code',
												'Kuduz Profilaksi Izlem Veri Seti' AS 'messageType/@value' ,
												LEFT(REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(19),GETDATE(),120),' ',''),'-',''),':',''),12) AS  'documentGenerationTime/@value',
												(	 
													 SELECT
														'1' AS  'healthcareProvider/@version',
														 'c3eade04-4f91-5dab-e043-14031b0ac9f9' AS  'healthcareProvider/@codeSystemGuid',
														SAGLIKNETKURUMKODU AS 'healthcareProvider/@code',
														SUBELER_SUBEADI as 'healthcareProvider/@value'  
													 FOR XML PATH('author'), TYPE
												  ),
												  'C740D0288ED4C45FE0407C0A04162BDD'  AS 'firmaKodu/@value',
												  (

													 SELECT--RECORD DATA
														(
															SELECT
															   ISNULL(HDOSYA_SNOTAKIPNO,'') AS 'SYSTakipNo/@value'
															FOR XML PATH('HASTA_TAKIP_BILGISI'), TYPE
														),
														(																														
															SELECT --KUDUZ_PROFILAKSI_IZLEM
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) = 1  THEN IMMUNOGLOBULINMIKTARI END AS 'IMMUNGLOBULIN_MIKTARI/@value',--Koşullu
															'1' AS 'KUDUZ_PROFILAKSISI_SONLANDIRMA_DURUMU/@version',															
															'033f9c18-2d1b-41a1-a605-082595f93632 ' AS 'KUDUZ_PROFILAKSISI_SONLANDIRMA_DURUMU/@codeSystemGuid',
														    PROFLAKSISONLANDIRMAID  AS 'KUDUZ_PROFILAKSISI_SONLANDIRMA_DURUMU/@code', -- Sonlandırma Durumu Zorunlu
															PROFLAKSISONLANDIRMAADI  AS 'KUDUZ_PROFILAKSISI_SONLANDIRMA_DURUMU/@value',
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) = 1  THEN  '1' END AS 'IMMUNGLOBULIN_TURU/@version', --Koşullu															
															CASE WHEN ISNULL(IMMUNOGLOBULINTURUID,0) <> 0 THEN  'ecdaec49-6f7c-4fa9-9cbd-2dd40cfe39d1' END AS 'IMMUNGLOBULIN_TURU/@codeSystemGuid',
														    CASE WHEN ISNULL(IMMUNOGLOBULINTURUID,0) <> 0 THEN IMMUNOGLOBULINTURUID END AS 'IMMUNGLOBULIN_TURU/@code',
															CASE WHEN ISNULL(IMMUNOGLOBULINTURUID,0) <> 0 THEN PROFLAKSISONLANDIRMAADI END AS 'IMMUNGLOBULIN_TURU/@value',															 
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) <> 0 THEN  '1' END AS 'UYGULANAN_KUDUZ_PROFILAKSISI_BILGISI/@version',															
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) <> 0 THEN  'db1af0ba-193c-424f-a2fe-710001d552c9' END AS 'UYGULANAN_KUDUZ_PROFILAKSISI_BILGISI/@codeSystemGuid',
														    CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) <> 0 THEN UYGULANANPROFLAKSIID END AS 'UYGULANAN_KUDUZ_PROFILAKSISI_BILGISI/@code',
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) <> 0 THEN UYGKPROFLAKSISIADI END AS 'UYGULANAN_KUDUZ_PROFILAKSISI_BILGISI/@value',																										
															CASE WHEN ISNULL(UYGULANANPROFLAKSIID,0) = 1 THEN KILO END AS 'KILO/@value' --Koşullu
															FROM #TMPKUDUZIZLEM
																	
															FOR XML PATH('KUDUZ_PROFILAKSI_IZLEM'), TYPE
														)
												  FOR XML PATH('recordData'), TYPE
											  )
	
										FROM #TMPDOSYA 

										FOR XML PATH (''), ROOT('SYSMessage')

									) AS GONDERILECEKXML,
									@HATA AS HATA, 
									@MESAJ AS MESAJ,
									@XMLBASLIK AS XMLBASLIK,
									@HKUDUZIZLEMID AS TABLOID,
									'' AS MINID,
									'' AS MAXID

							END TRY
							BEGIN CATCH
								SET @HATA = ERROR_MESSAGE()
								IF @HATA = ''
									SET @HATA = 'Bilinmeyen bir hata oluştu'

								INSERT INTO @GONDERIMTABLOSU (GONDERILECEKXML,HATA,MESAJ,XMLBASLIK,TABLOID,MINID,MAXID)
								SELECT	'' AS GONDERILECEKXML,
										@HATA AS HATA, 
										@MESAJ AS MESAJ,
										'' AS XMLBASLIK,
										@HKUDUZIZLEMID AS TABLOID,
										0 AS MINID,
										0 AS MAXID
			

							END CATCH				


		

	END
	ELSE
	BEGIN

		INSERT INTO @GONDERIMTABLOSU (GONDERILECEKXML,HATA,MESAJ,XMLBASLIK,TABLOID,MINID,MAXID)
		SELECT	'' AS GONDERILECEKXML,
				@HATA AS HATA, 
				@MESAJ AS MESAJ,
				'' AS XMLBASLIK,
				@HKUDUZIZLEMID AS TABLOID,
				0 AS MINID,
				0 AS MAXID	

		SET @HATA = ''	 
	END


	
	IF OBJECT_ID('tempdb..#TMPDOSYA') IS NOT NULL 
		DROP TABLE #TMPDOSYA

	IF OBJECT_ID('tempdb..#TMPKUDUZIZLEM') IS NOT NULL 
		DROP TABLE #TMPKUDUZIZLEM


	SELECT * FROM @GONDERIMTABLOSU


END
